// C Source File
// Created 12.01.02; 21:23:17

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
#include "extgraph.h"
#define SIZE     100
short _ti92plus;              // Produce .9XZ File
void InputStr (char*, short, short, short);


// Main Function
void _main(void)
{
short   x, y, count;
    long double zr, zi, cr, ci;
    long double rsquared, isquared;
long double  MaxIters, xAchse, yAchse, Spaltenbreite, Quad;
char buffer[50];
ClrScr();
DrawStr(1,10,"X-Achse",A_NORMAL);
InputStr(buffer,20,1,20);
xAchse =  atoi (buffer);

DrawStr(1,30,"Y-Achse",A_NORMAL);
InputStr(buffer,20,1,40);
yAchse =  atoi (buffer);

DrawStr(1,50,"Quad",A_NORMAL);
InputStr(buffer,20,1,60);
Quad=atoi (buffer);

DrawStr(1,70,"Iteration",A_NORMAL);
InputStr(buffer,20,1,80);
MaxIters=atoi (buffer);


		ClrScr();
    for (y = 0; y < SIZE; y++)
    {
        for (x = 0; x < SIZE; x++)
        {
            zr = 0.0;
            zi = 0.0;
            //cr = LEFT + x * (RIGHT - LEFT) / SIZE;
						//ci = TOP + y * (BOTTOM - TOP) / SIZE;
						
						Spaltenbreite= (Quad) / (SIZE*0.75);
						cr=x * Spaltenbreite+xAchse;
						ci=y * Spaltenbreite+yAchse;
						
						
            rsquared = zr * zr;
            isquared = zi * zi;

            for (count = 0; rsquared + isquared <= 4.0
                            && count < MaxIters; count++)
            {
                zi = zr * zi * 2;
                zi += ci;

                zr = rsquared - isquared;
                zr += cr;

                rsquared = zr * zr;
                isquared = zi * zi;
            }

            if (rsquared + isquared <= 4.0)
                //printf("*");  
                							DrawPix (x,y, A_NORMAL);  
                							//SETPIX(p,x,y);
                										//EXT_SETPIX(LCD_MEM,x,y);


            //else
                //printf(" ");  
              //  DrawPix (x,y, A_NORMAL);  
        }
        }
        //printf("\n");
    //return 0;
ngetchx();
{
SCR_RECT full_screen = {{0, 0, 239, 127}};
  char buffer [BITMAP_HDR_SIZE + 240*130/8];
  BitmapGet (&full_screen, buffer); 
  clrscr ();
  printf ("Bild abspeichern...");
  ngetchx ();
  BitmapPut (0, 0, buffer, &full_screen, A_REPLACE);
  ngetchx();
 {
FILE *f;
f = fopen ("frac", "wb");

	fwrite (buffer,BITMAP_HDR_SIZE+240*130/8,1,f);
  fputc (PIC_TAG, f);
fclose (f);
}
}



}

void InputStr (char *buffer, short maxlen, short xini, short yini)
{
short key, i = 0;
OSTimerRestart(APD_TIMER);
strcpy(buffer,"\0");
do
{
        MoveTo(xini,yini);
        printf ("%s_ ", buffer);
key = GKeyIn(NULL,0);
if (key >=45 && key <=57 && i < maxlen) buffer[i++] = key;
if (key == KEY_BACKSPACE && i) i--;
buffer[ i ] = 0;
if(key==KEY_CLEAR)
{
        strcpy(buffer,"\0") ;
        i=0;
}
} while (key != KEY_ENTER);
        ST_busy(ST_CLEAR);
}

